# Sample Problem 1 (Ex 1 from Dynopt Guide)
#
#	min X2(tf)
#	s.t.	X1_dot = u			X1(0) = 1
#		X2_dot = X1^2 + u^2		X2(0) = 0
#		tf = 1

from coopr.pyomo import *
from coopr.dae import *

m = ConcreteModel()

m.t = DifferentialSet(bounds=(0,1)) 
m.x1 = Var(m.t, bounds=(0,1))
m.x2 = Var(m.t, bounds=(0,1))
m.u = Var(m.t, initialize=0)

m.obj = Objective(expr=m.x2[1])

def _x1dot(M,i):
	return M.u[i]
m.x1dot = Differential(dvar=m.x1, rule=_x1dot)

def _x2dot(M,i):
	return M.x1[i]**2 + M.u[i]**2
m.x2dot = Differential(dvar=m.x2, rule=_x2dot)

def _init(M):
	yield M.x1[0] == 1
	yield M.x2[0] == 0
	yield ConstraintList.End
m.init_conditions = ConstraintList(rule=_init)

